## libxml2 2.9.14+dfsg

=== debian/changelog ===
libxml2 (2.9.14+dfsg-0+0~20220524.12+debian9~1.gbpc5dc45) unstable; urgency=medium

  ** SNAPSHOT build @c5dc459cca2b5e167c372b155917f40e0d30eaa2 **

  * UNRELEASED

 -- Ondřej Surý <ondrej@sury.org>  Tue, 24 May 2022 21:25:54 +0200

libxml2 (2.9.14+dfsg-0) unstable; urgency=medium

  * New upstream version 2.9.14+dfsg

 -- Ondřej Surý <ondrej@debian.org>  Tue, 24 May 2022 21:08:31 +0200

libxml2 (2.9.13+dfsg-0) unstable; urgency=medium

  * New upstream version 2.9.13+dfsg
  * Update d/gbp.conf
  * Sync docs with master branch

 -- Ondřej Surý <ondrej@debian.org>  Mon, 14 Mar 2022 17:39:47 +0100

libxml2 (2.9.12+dfsg-0) unstable; urgency=medium

  * New upstream version 2.9.12+dfsg
  * DEB.SURY.ORG upload
  * Remove patches merged upstream
  * Update the debian/libxml2.symbols for 2.9.11+

 -- Ondřej Surý <ondrej@debian.org>  Mon, 21 Jun 2021 07:03:09 +0200

libxml2 (2.9.10+dfsg-6) UNRELEASED; urgency=medium

  * Use correct machine-readable copyright file URI.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Rely on pre-initialized dpkg-architecture variables.

 -- Debian Janitor <janitor@jelmer.uk>  Tue, 28 Apr 2020 07:25:00 +0000

=== debian/control ===
Source: libxml2
Priority: optional
Section: libs
Maintainer: Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>
Uploaders:
 Aron Xu <aron@debian.org>,
 YunQiang Su <wzssyqa@gmail.com>,
Build-Depends:
 debhelper (>= 10),
 dh-python,
 libicu-dev,
 liblzma-dev,
 libpython-all-dbg,
 libpython-all-dev,
 libpython3-all-dbg,
 libpython3-all-dev,
 pkg-config,
 python-all-dbg:any,
 python-all-dev:any (>= 2.7.5-5~),
 python3-all-dbg:any,
 python3-all-dev:any,
 rename,
 zlib1g-dev | libz-dev,
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: http://xmlsoft.org
Vcs-Git: https://salsa.debian.org/xml-sgml-team/libxml2.git
Vcs-Browser: https://salsa.debian.org/xml-sgml-team/libxml2

Package: libxml2
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: same
Description: GNOME XML library
 XML is a metalanguage to let you design your own markup language.
 A regular markup language defines a way to describe information in
 a certain class of documents (eg HTML). XML lets you define your
 own customized markup languages for many classes of document. It
 can do this because it's written in SGML, the international standard
 metalanguage for markup languages.
 .
 This package provides a library providing an extensive API to handle
 such XML data files.

Package: libxml2-utils
Architecture: any
Section: text
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: foreign
Description: XML utilities
 XML is a metalanguage to let you design your own markup language.
 A regular markup language defines a way to describe information in
 a certain class of documents (eg HTML). XML lets you define your
 own customized markup languages for many classes of document. It
 can do this because it's written in SGML, the international standard
 metalanguage for markup languages.
 .
 This package provides xmllint, a tool for validating and reformatting
 XML documents, and xmlcatalog, a tool to parse and manipulate XML or
 SGML catalog files.

Package: libxml2-dev
Architecture: any
Section: libdevel
Depends:
 libicu-dev,
 libxml2 (= ${binary:Version}),
 ${misc:Depends},
Suggests:
 pkg-config,
Multi-Arch: same
Description: Development files for the GNOME XML library
 XML is a metalanguage to let you design your own markup language.
 A regular markup language defines a way to describe information in
 a certain class of documents (eg HTML). XML lets you define your
 own customized markup languages for many classes of document. It
 can do this because it's written in SGML, the international standard
 metalanguage for markup languages.
 .
 Install this package if you wish to develop your own programs using
 the GNOME XML library.

Package: libxml2-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
Suggests:
 devhelp,
Multi-Arch: foreign
Description: Documentation for the GNOME XML library
 XML is a metalanguage to let you design your own markup language.
 A regular markup language defines a way to describe information in
 a certain class of documents (eg HTML). XML lets you define your
 own customized markup languages for many classes of document. It
 can do this because it's written in SGML, the international standard
 metalanguage for markup languages.
 .
 This package contains general information about the GNOME XML library
 and more specific API references.

Package: python-libxml2
Architecture: any
Section: python
Depends:
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends},
Description: Python bindings for the GNOME XML library
 XML is a metalanguage to let you design your own markup language.
 A regular markup language defines a way to describe information in
 a certain class of documents (eg HTML). XML lets you define your
 own customized markup languages for many classes of document. It
 can do this because it's written in SGML, the international standard
 metalanguage for markup languages.
 .
 This package contains the files needed to use the GNOME XML library
 in Python programs.

Package: python-libxml2-dbg
Architecture: any
Section: debug
Depends:
 python-libxml2 (= ${binary:Version}),
 ${misc:Depends},
 ${python:Depends},
 ${shlibs:Depends},
Description: Python bindings for the GNOME XML library (debug extension)
 XML is a metalanguage to let you design your own markup language.
 A regular markup language defines a way to describe information in
 a certain class of documents (eg HTML). XML lets you define your
 own customized markup languages for many classes of document. It
 can do this because it's written in SGML, the international standard
 metalanguage for markup languages.
 .
 This package contains the files needed to use the GNOME XML library
 in Python programs for use with the Python debug interpreter.

Package: python3-libxml2
Architecture: any
Section: python
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python3 bindings for the GNOME XML library
 XML is a metalanguage to let you design your own markup language.
 A regular markup language defines a way to describe information in
 a certain class of documents (eg HTML). XML lets you define your
 own customized markup languages for many classes of document. It
 can do this because it's written in SGML, the international standard
 metalanguage for markup languages.
 .
 This package contains the files needed to use the GNOME XML library
 in Python3 programs.

Package: python3-libxml2-dbg
Architecture: any
Section: debug
Multi-Arch: same
Depends:
 python3-libxml2 (= ${binary:Version}),
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: Python3 bindings for the GNOME XML library (debug extension)
 XML is a metalanguage to let you design your own markup language.
 A regular markup language defines a way to describe information in
 a certain class of documents (eg HTML). XML lets you define your
 own customized markup languages for many classes of document. It
 can do this because it's written in SGML, the international standard
 metalanguage for markup languages.
 .
 This package contains the files needed to use the GNOME XML library
 in Python3 programs for use with the Python3 debug interpreter.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1

# The versions of python currently supported
PYVERS=$(shell pyversions -s)
PY3VERS=$(shell py3versions -s)
# The current default version of python
PYVER=$(shell pyversions -d)
PY3VER=$(shell py3versions -d)

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -O3
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

include /usr/share/dpkg/architecture.mk

TARGETS := main $(PYVERS) $(PYVERS:%=%-dbg) $(PY3VERS) $(PY3VERS:%=%-dbg)

CONFIGURE_FLAGS := --with-history --cache-file="$(CURDIR)/builddir/config.cache"

override_dh_auto_configure: $(TARGETS:%=doconfigure-%)

doconfigure-%:
	dh_auto_configure --builddirectory=builddir/$(*) -- $(CONFIGURE_FLAGS)
	touch $@

doconfigure-main: CONFIGURE_FLAGS += --without-python --with-icu
doconfigure-python%: CONFIGURE_FLAGS += --with-python=/usr/bin/$(subst -dbg,,$(*)) --with-python-install-dir=/usr/lib/$(subst -dbg,,$(*))/dist-packages

dobuild-%: BUILD_DIR=builddir/$(*)
dobuild-%: doconfigure-%
	$(if $(filter $(BUILD_DIR),builddir/$(*)),,[ -d $(BUILD_DIR) ] || mv builddir/$(*)/python $(BUILD_DIR))
	dh_auto_build --builddirectory=$(BUILD_DIR) -- $(BUILD_FLAGS)

dobuild-python%: BUILD_DIR=builddir/main/$(*)
dobuild-python%: BUILD_FLAGS=libxml2mod_la_LIBADD='$$(mylibs)' \
    PYTHON_INCLUDES='$(shell $(DEB_HOST_GNU_TYPE)-$(*)-config --includes)' \
    PYTHON_LIBS='$(shell $(DEB_HOST_GNU_TYPE)-$(*)-config --ldflags)'
dobuild-python%-dbg: BUILD_FLAGS+=PYTHON_INCLUDES='$(shell $(DEB_HOST_GNU_TYPE)-$(*)-config --includes)' \
    PYTHON_LIBS='$(shell $(DEB_HOST_GNU_TYPE)-$(*)-config --ldflags)' \
    CFLAGS='$(CFLAGS) -Wall -g -O0' CPPFLAGS='$(CPPFLAGS)' LDFLAGS='$(LDFLAGS) \
    -L$(CURDIR)/debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)'

override_dh_auto_build-arch: $(TARGETS:%=dobuild-%)
override_dh_auto_build-indep: dobuild-main

override_dh_auto_clean:
	rm -rf builddir debian/tmp-dbg
	rm -f doconfigure-*
	dh_auto_clean

doinstall-main:
	dh_auto_install --builddirectory=builddir/main
	mv debian/tmp/usr/share/aclocal/libxml.m4 debian/tmp/usr/share/aclocal/libxml2.m4

override_dh_auto_install-arch: $(TARGETS:%=doinstall-%)
	find debian/tmp -name *.la -delete

override_dh_auto_install-indep: doinstall-main
	find debian/tmp -name *.la -delete
	# Properly install documentation in /usr/share/doc/libxml2-doc
	install -d debian/tmp/usr/share/doc/libxml2-doc/examples
	install -m 644 \
		doc/*.html \
		doc/*.gif \
		doc/*.png \
		doc/libxml2-api.xml debian/tmp/usr/share/doc/libxml2-doc
	install -m 644 \
		doc/examples/*.c \
		doc/examples/*.res \
		doc/examples/index.html \
		doc/examples/[tw]*.xml debian/tmp/usr/share/doc/libxml2-doc/examples
	cp -a \
		doc/html \
		doc/tutorial debian/tmp/usr/share/doc/libxml2-doc

doinstall-python%-dbg:
	$(MAKE) -C builddir/main/python$(*)-dbg DESTDIR=$(CURDIR)/debian/tmp-dbg install-pythonLTLIBRARIES
	rename -v -f 's/(?<!_d)\.so$$/_d.so/' debian/tmp-dbg/usr/lib/python$(*)/*-packages/*.so

doinstall-python%:
	dh_auto_install --builddirectory=builddir/main/python$(*)

override_dh_compress:
	dh_compress -Xexamples/ -Xtutorial/ -Xhtml/ -X.html

override_dh_installchangelogs:
	dh_installchangelogs -k NEWS

override_dh_install-arch:
	dh_install -Npython-libxml2-dbg -Npython3-libxml2-dbg
ifneq (,$(filter python-libxml2-dbg,$(DOPACKAGES)))
	dh_install -ppython-libxml2-dbg --sourcedir=debian/tmp-dbg
	dh_install -ppython3-libxml2-dbg --sourcedir=debian/tmp-dbg
endif
	sed -i -e 's,/lib/$(DEB_HOST_MULTIARCH),/lib,' debian/libxml2-dev/usr/bin/xml2-config

override_dh_strip:
ifneq (,$(filter python-libxml2 python-libxml2-dbg,$(DOPACKAGES)))
	dh_strip -ppython-libxml2 --dbg-package=python-libxml2-dbg
	dh_strip -ppython3-libxml2 --dbg-package=python3-libxml2-dbg
endif
	# Do not strip the python*-*-dbg packages, the python-dbg interpreter likes them
	dh_strip --remaining-packages -Npython3-libxml2-dbg

override_dh_makeshlibs:
	dh_makeshlibs -a -V 'libxml2 (>= 2.9.8)' -- -c4

%:
	dh $@ \
		$(if $(filter python-libxml2 python-libxml2-dbg,$(DOPACKAGES)),--with python2) \
		$(if $(filter python3-libxml2 python3-libxml2-dbg,$(DOPACKAGES)),--with python3)

## libxml2 2.12.7%2Bdfsg

=== debian/changelog ===
libxml2 (2.12.7+dfsg-2) unstable; urgency=medium

  * d/control: Depends on liblzma-dev and zlib1g-dev explicitly
    (Closes: #1071834)

 -- Aron Xu <aron@debian.org>  Sat, 25 May 2024 22:51:40 +0800

libxml2 (2.12.7+dfsg-1) unstable; urgency=medium

  * New upstream version 2.12.7+dfsg
  * CVE-2024-34459: buffer over-read in xmlHTMLPrintFileContext
    (Closes: 1071162).

 -- Aron Xu <aron@debian.org>  Sat, 25 May 2024 11:38:42 +0800

libxml2 (2.12.6+dfsg-0exp2) experimental; urgency=medium

  * Really fix libxml2mod import problem

 -- Aron Xu <aron@debian.org>  Tue, 19 Mar 2024 01:26:06 +0800

libxml2 (2.12.6+dfsg-0exp1) experimental; urgency=medium

  * New upstream version 2.12.6+dfsg
  * d/patches: add python-libadd-fix.patch (Closes: #1059094)
  * d/control: add python3-setuptools to B-D
  * d/rules: disable config.cache caching to make it happy to switch among Python versions
  * d/rules: build extensions for all supported Python3 versions

 -- Aron Xu <aron@debian.org>  Tue, 19 Mar 2024 01:09:12 +0800

libxml2 (2.12.5+dfsg-0exp1) experimental; urgency=medium

  * New upstream version 2.12.5+dfsg
  * d/rules: configure with --with-legacy --with-ftp --with-xptr-locs
    (Closes: #1059040)
  * d/libxml2.symbols: update
  * d/libxml2-doc.doc-base: update html path
  * d/control: remove M-A: same from python3-libxml2

 -- Aron Xu <aron@debian.org>  Thu, 15 Feb 2024 17:44:46 +0800

libxml2 (2.12.3+dfsg-0exp1) experimental; urgency=medium

  [ Mattia Rizzolo ]
  * simplify list of html to install

  [ Bastian Germann ]
  * No icu dependency with noi18n build profile (Closes: #962464)

  [ Aron Xu ]
  * New upstream version 2.12.3+dfsg
  * Remove not needed patches
  * Refresh xml2-config-fix.patch
  * Update d/libxml2-dev.{install,manpages}
  * d/rules: update * remove __pycache__ directory from d/tmp *
    no need to remove files from dh_auto_install-indep
  * d/libxml2.symbols: update symbols
  * Update std-ver to 3.6.2, no change required
  * add source lintian override for documentation HTMLs
  * Update doc-base file to current location
  * Remove links that are not needed anymore
  * Remove lintian overrides that are not needed
  * d/rules: add a dfsg-source-tree target to clean up upstream tree

 -- Aron Xu <aron@debian.org>  Thu, 14 Dec 2023 11:55:58 +0800

libxml2 (2.9.14+dfsg-1) unstable; urgency=high

  * Team upload.
  * New upstream version 2.9.14+dfsg.
    + Integer overflows in xmlBuf/xmlBuffer.  CVE-2022-29824 Closes: #1010526

 -- Mattia Rizzolo <mattia@debian.org>  Thu, 05 May 2022 14:43:51 +0200

=== debian/control ===
Source: libxml2
Priority: optional
Section: libs
Maintainer: Debian XML/SGML Group <debian-xml-sgml-pkgs@lists.alioth.debian.org>
Uploaders:
 Aron Xu <aron@debian.org>,
 YunQiang Su <wzssyqa@gmail.com>,
Build-Depends:
 debhelper-compat (= 13),
Build-Depends-Indep:
 pkg-config,
Build-Depends-Arch:
 dh-sequence-python3 <!nopython>,
 libicu-dev <!noi18n>,
 liblzma-dev,
 libpython3-all-dev <!nopython>,
 pkg-config,
 python3-all-dev:any (>= 3.5) <!nopython>,
 python3-setuptools,
 rename,
 zlib1g-dev | libz-dev,
Standards-Version: 4.6.2
Rules-Requires-Root: no
Homepage: http://xmlsoft.org
Vcs-Git: https://salsa.debian.org/xml-sgml-team/libxml2.git
Vcs-Browser: https://salsa.debian.org/xml-sgml-team/libxml2
Description: GNOME XML library
 XML is a metalanguage to let you design your own markup language.
 A regular markup language defines a way to describe information in
 a certain class of documents (eg HTML). XML lets you define your
 own customized markup languages for many classes of document. It
 can do this because it's written in SGML, the international standard
 metalanguage for markup languages.

Package: libxml2
Architecture: any
Pre-Depends:
 ${misc:Pre-Depends},
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Conflicts:
 w3c-dtd-xhtml,
Multi-Arch: same
Description: ${source:Synopsis}
 ${source:Extended-Description}
 .
 This package provides a library providing an extensive API to handle
 such XML data files.

Package: libxml2-utils
Architecture: any
Section: text
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Multi-Arch: foreign
Description: ${source:Synopsis} - utilities
 ${source:Extended-Description}
 .
 This package provides xmllint, a tool for validating and reformatting
 XML documents, and xmlcatalog, a tool to parse and manipulate XML or
 SGML catalog files.

Package: libxml2-dev
Architecture: any
Section: libdevel
Depends:
 libicu-dev,
 liblzma-dev,
 libxml2 (= ${binary:Version}),
 zlib1g-dev,
 ${misc:Depends},
Suggests:
 pkg-config,
Multi-Arch: same
Description: ${source:Synopsis} - development files
 ${source:Extended-Description}
 .
 Install this package if you wish to develop your own programs using
 the GNOME XML library.

Package: libxml2-doc
Architecture: all
Section: doc
Depends:
 ${misc:Depends},
Suggests:
 devhelp,
Multi-Arch: foreign
Description: ${source:Synopsis} - documentation
 ${source:Extended-Description}
 .
 This package contains general information about the GNOME XML library
 and more specific API references.

Package: python3-libxml2
Architecture: any
Build-Profiles: <!nopython>
Section: python
Depends:
 ${misc:Depends},
 ${python3:Depends},
 ${shlibs:Depends},
Description: ${source:Synopsis} - Python3 bindings
 ${source:Extended-Description}
 .
 This package contains the files needed to use the GNOME XML library
 in Python3 programs.

## libxml2 2.12.7%2Bdfsg%2Breally2.9.14

=== debian/changelog ===
libxml2 (2.12.7+dfsg+really2.9.14-0.4ubuntu0.3) plucky-security; urgency=medium

  * SECURITY UPDATE: Stack overflow
    - debian/patches/CVE-2025-9714.patch: Make XPath depth check work with
      recursive invocations.
    - CVE-2025-9714

 -- Octavio Galland <octavio.galland@canonical.com>  Mon, 01 Sep 2025 12:07:38 -0300

libxml2 (2.12.7+dfsg+really2.9.14-0.4ubuntu0.2) plucky-security; urgency=medium

  * SECURITY UPDATE: stack-based buffer overflow
    - debian/patches/CVE-2025-6021.patch: fix integer overflow by adding
      bound checks in xmlBuildQName in tree.c
      prevent integer overflow
    - debian/patches/CVE-2025-6170.patch: fix buffer overflow by adding
      bound checks in xmlShell in debugXML.c
    - CVE-2025-6021
    - CVE-2025-6170
  * SECURITY UPDATE: UAF and type confusion
    - debian/patches/CVE-2025-49794_49796.patch: fix UAF by returning node
      and freeing it after use; fix type confusion by adding type check in
      xmlSchematronFormatReport in schematron.c
    - CVE-2025-49794
    - CVE-2025-49796

 -- Shishir Subedi <shishir.subedi@canonical.com>  Fri, 08 Aug 2025 14:41:54 +0545

libxml2 (2.12.7+dfsg+really2.9.14-0.4ubuntu0.1) plucky-security; urgency=medium

  * SECURITY UPDATE: OOB access in python API
    - debian/patches/CVE-2025-32414-pre1.patch: fix SAX driver with
      character streams in python/drv_libxml2.py.
    - debian/patches/CVE-2025-32414-1.patch: read at most len/4 characters
      in python/libxml.c.
    - debian/patches/CVE-2025-32414-2.patch: add a test in
      python/tests/Makefile.am, python/tests/unicode.py.
    - CVE-2025-32414
  * SECURITY UPDATE: heap under-read in xmlSchemaIDCFillNodeTables
    - debian/patches/CVE-2025-32415.patch: fix heap buffer overflow in
      xmlSchemaIDCFillNodeTables in xmlschemas.c.
    - CVE-2025-32415

 -- Marc Deslauriers <marc.deslauriers@ubuntu.com>  Thu, 24 Apr 2025 14:42:32 -0400

libxml2 (2.12.7+dfsg+really2.9.14-0.4) unstable; urgency=medium

  * Non-maintainer upload.

  * Don't build with ICU. Closes: #1092484.

    libxml's README.md states:

    [ICU](https://icu.unicode.org/), a Unicode library. Mainly
    useful as an alternative to iconv on Windows. Unnecessary
    on most other systems.

    ICU 76.1 requires to be built with -std=c++17 or -std=gnu++17 or
    higher.  However including the ICU headers in the libxml2 headers,
    breaks builds with older C++ standards, most likely leading to
    some unrelated build failures for packages that don't rely on ICU,
    but are using libxml2.

  * Import security updates from Ubuntu:
    - SECURITY UPDATE: use-after-free in xmlXIncludeAddNode
      + debian/patches/CVE-2022-49043.patch: fix UaF in xinclude.c.
      + CVE-2022-49043. Closes: #1094238.
    - SECURITY UPDATE: buffer overread in xmllint
      + debian/patches/CVE-2024-34459.patch: fix buffer issue when using
        htmlout option in xmllint.c.
      + CVE-2024-34459. Closes: #1071162.
    - SECURITY UPDATE: use-after-free
      + debian/patches/CVE-2024-56171.patch: Fix use-after-free after
        xmlSchemaItemListAdd.
      + CVE-2024-56171. Closes: #1098320.
    - SECURITY UPDATE: stack-based buffer overflow
      + debian/patches/CVE-2025-24928-pre1.patch: Check for NULL node->name
        in xmlSnprintfElements.
      + debian/patches/CVE-2025-24928.patch: Fix stack-buffer-overflow in
        xmlSnprintfElements.
      + CVE-2025-24928. Closes: #1098321.
    - SECURITY UPDATE: NULL pointer dereference
      + debian/patches/CVE-2025-27113.patch: Fix compilation of explicit
        child axis.
      + CVE-2025-27113. Closes: #1098322.

 -- Matthias Klose <doko@debian.org>  Thu, 27 Mar 2025 11:54:17 +0100

libxml2 (2.12.7+dfsg+really2.9.14-0.3) unstable; urgency=medium

  * Non-maintainer upload.
  * debian/control: Add python3-setuptools to Build-Depends (Closes: #1099843)

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 13 Mar 2025 21:31:54 +0100

libxml2 (2.12.7+dfsg+really2.9.14-0.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Patch: Python 3.13 support. (Closes: #1084096)

 -- Stefano Rivera <stefanor@debian.org>  Wed, 06 Nov 2024 17:11:20 -0800

libxml2 (2.12.7+dfsg+really2.9.14-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Revert packaging to 2.9.14+dfsg-1.3 currently in testing to revert ABI
    breakage (Closes: #1073508)

 -- Sebastian Ramacher <sramacher@debian.org>  Thu, 26 Sep 2024 17:15:36 +0200

libxml2 (2.9.14+dfsg-1.3) unstable; urgency=medium

  * Non-maintainer upload.
  * Reset nsNr in xmlCtxtReset (CVE-2022-2309) (Closes: #1039991)
  * Also reset nsNr in htmlCtxtReset (CVE-2022-2309) (Closes: #1039991)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 08 Jul 2023 21:18:29 +0200

libxml2 (2.9.14+dfsg-1.2) unstable; urgency=medium

  * Non-maintainer upload.
  * schemas: Fix null-pointer-deref in xmlSchemaCheckCOSSTDerivedOK
  * Fix null deref in xmlSchemaFixupComplexType (CVE-2023-28484)
    (Closes: #1034436)
  * Hashing of empty dict strings isn't deterministic (CVE-2023-29469)
    (Closes: #1034437)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sat, 15 Apr 2023 16:25:06 +0200

libxml2 (2.9.14+dfsg-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix integer overflows with XML_PARSE_HUGE (CVE-2022-40303)
    (Closes: #1022224)
  * Fix dict corruption caused by entity reference cycles (CVE-2022-40304)
    (Closes: #1022225)

 -- Salvatore Bonaccorso <carnil@debian.org>  Sun, 30 Oct 2022 11:18:06 +0100

## libxml2 2.12.7+dfsg

=== debian/changelog ===
libxml2 (2.12.7+dfsg-3) unstable; urgency=medium

  * d/control: replace pkg-config with pkgconf
  * source: override invalid-profile-name-in-source-relation noi18n
  * d/control: versioned Breaks at libxml-libxml-perl

 -- Aron Xu <aron@debian.org>  Wed, 29 May 2024 21:25:11 +0800

=== debian/control ===
--- 
+++ 
@@ -8,13 +8,13 @@
 Build-Depends:
  debhelper-compat (= 13),
 Build-Depends-Indep:
- pkg-config,
+ pkgconf,
 Build-Depends-Arch:
  dh-sequence-python3 <!nopython>,
  libicu-dev <!noi18n>,
  liblzma-dev,
  libpython3-all-dev <!nopython>,
- pkg-config,
+ pkgconf,
  python3-all-dev:any (>= 3.5) <!nopython>,
  python3-setuptools,
  rename,
@@ -41,6 +41,8 @@
  ${shlibs:Depends},
 Conflicts:
  w3c-dtd-xhtml,
+Breaks:
+ libxml-libxml-perl (<< 2.0207+dfsg+really+2.0134-3~),
 Multi-Arch: same
 Description: ${source:Synopsis}
  ${source:Extended-Description}
@@ -72,7 +74,7 @@
  zlib1g-dev,
  ${misc:Depends},
 Suggests:
- pkg-config,
+ pkgconf,
 Multi-Arch: same
 Description: ${source:Synopsis} - development files
  ${source:Extended-Description}

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1

DOPACKAGES = $(shell dh_listpackages)

ifneq (,$(filter python3-libxml2,$(DOPACKAGES)))
# The versions of python3 currently supported
PY3VERS=$(shell py3versions -s)
else
PY3VERS=
endif

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CFLAGS_MAINT_APPEND = -Wall -O3

include /usr/share/dpkg/architecture.mk

TARGETS := main $(PY3VERS)

CONFIGURE_FLAGS := --with-history \
		   --with-legacy \
		   --with-ftp \
		   --with-xptr-loc

override_dh_auto_configure-arch: $(TARGETS:%=doconfigure-%)

override_dh_auto_configure-indep:
	dh_auto_configure -- --docdir \$${prefix}/share/doc/libxml2 --enable-rebuild-docs --with-python=no

doconfigure-%:
	export PYTHON=$(PYTHON) && dh_auto_configure --builddirectory=builddir/$(*) -- $(CONFIGURE_FLAGS) && unset PYTHON
	touch $@

ifeq (,$(filter noi18n,$(DEB_BUILD_PROFILES)))
doconfigure-main: CONFIGURE_FLAGS += --with-python=no --with-icu
else
doconfigure-main: CONFIGURE_FLAGS += --with-python=no
endif
doconfigure-python%: CONFIGURE_FLAGS += --with-python
	#PYTHON_VERSION=$(subst python,,$(*))
	PYTHON=$(shell which $(*))

dobuild-%: BUILD_DIR=builddir/$(*)
dobuild-%: doconfigure-%
	$(if $(filter $(BUILD_DIR),builddir/$(*)),,[ -d $(BUILD_DIR) ] || mv builddir/$(*)/python $(BUILD_DIR))
	dh_auto_build --builddirectory=$(BUILD_DIR) -- $(BUILD_FLAGS)

dobuild-python%: BUILD_DIR=builddir/main/$(*)
dobuild-python%: BUILD_FLAGS=libxml2mod_la_LIBADD='$$(mylibs)' \
    PYTHON_INCLUDES='$(shell $(DEB_HOST_GNU_TYPE)-$(*)-config --includes)' \
    PYTHON_LIBS='$(shell $(DEB_HOST_GNU_TYPE)-$(*)-config --ldflags)'

override_dh_auto_build-arch: $(TARGETS:%=dobuild-%)

override_dh_auto_build-indep:
	dh_auto_build -i

override_dh_auto_test-indep:
	: Skipping tests during indep build

execute_after_dh_auto_clean:
	rm -rf builddir
	rm -f doconfigure-*

doinstall-main:
	dh_auto_install --builddirectory=builddir/main
	mv debian/tmp/usr/share/aclocal/libxml.m4 debian/tmp/usr/share/aclocal/libxml2.m4

override_dh_auto_install-arch: $(TARGETS:%=doinstall-%)
	find debian/tmp -name *.la -delete
	rm -r debian/tmp/usr/lib/python*/site-packages/__pycache__

doinstall-python%:
	dh_auto_install --builddirectory=builddir/main/python$(*)

override_dh_compress:
	dh_compress -Xexamples/ -Xtutorial/ -Xhtml/ -X.html

override_dh_installchangelogs:
	dh_installchangelogs -k NEWS

override_dh_install-arch:
	dh_install -a
	sed -i -e 's,/lib/$(DEB_HOST_MULTIARCH),/lib,' debian/libxml2-dev/usr/bin/xml2-config

override_dh_makeshlibs:
	dh_makeshlibs -plibxml2 -V 'libxml2 (>= 2.9.11)' -- -c4
	dh_makeshlibs --remaining-packages

#  I need to specify all the targets (build, binary, clean, etc) as
#  otherwise dh may invoke them in a order that is not appropriate for the
#  build system (the -indep part is done in-tree because rebuilding the
#  docs out of tree is not supported.  And once an in-tree build is done no
#  out-of-tree builds can be done, so we wouldn't be able to do the -arch
#  builds after the -indep one).
clean build-arch binary-arch build-indep binary-indep:
	dh $@

build: build-arch build-indep
binary: binary-arch binary-indep

dfsg-source-tree:
	rm -rf test/
	rm -rf result/

## libxml2 2.12.7+dfsg+really2.9.14

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.15)

file(STRINGS "configure.ac" CONFIGURE_AC_LINES)
foreach(line ${CONFIGURE_AC_LINES})
	if(line MATCHES [[^m4_define\(\[(MAJOR_VERSION|MINOR_VERSION|MICRO_VERSION)\],[ \t]*([0-9]+)\)$]])
		set(LIBXML_${CMAKE_MATCH_1} ${CMAKE_MATCH_2})
	elseif(line MATCHES "^(LIBXML_MAJOR_VERSION|LIBXML_MINOR_VERSION|LIBXML_MICRO_VERSION)=([0-9]+)$")
		set(${CMAKE_MATCH_1} ${CMAKE_MATCH_2})
	endif()
endforeach()
set(VERSION "${LIBXML_MAJOR_VERSION}.${LIBXML_MINOR_VERSION}.${LIBXML_MICRO_VERSION}")

project(libxml2 VERSION ${VERSION} LANGUAGES C)

include(CheckCSourceCompiles)
include(CheckFunctionExists)
include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckStructHasMember)
include(CheckSymbolExists)
include(CMakePackageConfigHelpers)
include(GNUInstallDirs)

option(BUILD_SHARED_LIBS "Build shared libraries" ON)
set(LIBXML2_WITH_AUTOMATA ON)
option(LIBXML2_WITH_C14N "Add the Canonicalization support" ON)
option(LIBXML2_WITH_CATALOG "Add the Catalog support" ON)
option(LIBXML2_WITH_DEBUG "Add the debugging module" ON)
option(LIBXML2_WITH_DOCB "Add Docbook SGML support" ON)
set(LIBXML2_WITH_EXPR ON)
option(LIBXML2_WITH_FTP "Add the FTP support" ON)
option(LIBXML2_WITH_HTML "Add the HTML support" ON)
option(LIBXML2_WITH_HTTP "Add the HTTP support" ON)
option(LIBXML2_WITH_ICONV "Add ICONV support" ON)
option(LIBXML2_WITH_ICU "Add ICU support" OFF)
option(LIBXML2_WITH_ISO8859X "Add ISO8859X support if no iconv" ON)
option(LIBXML2_WITH_LEGACY "Add deprecated APIs for compatibility" ON)
option(LIBXML2_WITH_LZMA "Use liblzma" ON)
option(LIBXML2_WITH_MEM_DEBUG "Add the memory debugging module" OFF)
option(LIBXML2_WITH_MODULES "Add the dynamic modules support" ON)
option(LIBXML2_WITH_OUTPUT "Add the serialization support" ON)
option(LIBXML2_WITH_PATTERN "Add the xmlPattern selection interface" ON)
option(LIBXML2_WITH_PROGRAMS "Build programs" ON)
option(LIBXML2_WITH_PUSH "Add the PUSH parser interfaces" ON)
option(LIBXML2_WITH_PYTHON "Build Python bindings" ON)
option(LIBXML2_WITH_READER "Add the xmlReader parsing interface" ON)
option(LIBXML2_WITH_REGEXPS "Add Regular Expressions support" ON)
option(LIBXML2_WITH_RUN_DEBUG "Add the runtime debugging module" OFF)
option(LIBXML2_WITH_SAX1 "Add the older SAX1 interface" ON)
option(LIBXML2_WITH_SCHEMAS "Add Relax-NG and Schemas support" ON)
option(LIBXML2_WITH_SCHEMATRON "Add Schematron support" ON)
option(LIBXML2_WITH_TESTS "Build tests" ON)
option(LIBXML2_WITH_THREADS "Add multithread support" ON)
option(LIBXML2_WITH_THREAD_ALLOC "Add per-thread memory" OFF)
option(LIBXML2_WITH_TREE "Add the DOM like tree manipulation APIs" ON)
set(LIBXML2_WITH_TRIO OFF)
set(LIBXML2_WITH_UNICODE ON)
option(LIBXML2_WITH_VALID "Add the DTD validation support" ON)
option(LIBXML2_WITH_WRITER "Add the xmlWriter saving interface" ON)
option(LIBXML2_WITH_XINCLUDE "Add the XInclude support" ON)
option(LIBXML2_WITH_XPATH "Add the XPATH support" ON)
option(LIBXML2_WITH_XPTR "Add the XPointer support" ON)
option(LIBXML2_WITH_ZLIB "Use libz" ON)
set(LIBXML2_XMLCONF_WORKING_DIR ${CMAKE_CURRENT_BINARY_DIR} CACHE PATH "Working directory for XML Conformance Test Suite")

if(LIBXML2_WITH_ICONV)
	find_package(Iconv REQUIRED)
endif()

if(LIBXML2_WITH_ICU)
	find_package(ICU REQUIRED COMPONENTS data i18n uc)
endif()

if(LIBXML2_WITH_LZMA)
	find_package(LibLZMA REQUIRED)
endif()

if(LIBXML2_WITH_PYTHON)
	check_include_files(unistd.h HAVE_UNISTD_H)
	check_symbol_exists(F_GETFL fcntl.h HAVE_F_GETFL)
	if(HAVE_UNISTD_H AND HAVE_F_GETFL)
		find_package(Python COMPONENTS Interpreter Development REQUIRED)
	else()
		find_package(Python2 COMPONENTS Interpreter Development REQUIRED)
		add_library(Python::Python ALIAS Python2::Python)
		set(Python_EXECUTABLE ${Python2_EXECUTABLE})
		set(Python_SITEARCH ${Python2_SITEARCH})
	endif()
	set(LIBXML2_PYTHON_INSTALL_DIR ${Python_SITEARCH} CACHE PATH "Python bindings install directory")
endif()

if(LIBXML2_WITH_THREADS)
	find_package(Threads REQUIRED)
endif()

if(LIBXML2_WITH_ZLIB)
	find_package(ZLIB REQUIRED)
endif()

foreach(VARIABLE IN ITEMS WITH_AUTOMATA WITH_C14N WITH_CATALOG WITH_DEBUG WITH_DOCB WITH_EXPR WITH_FTP WITH_HTML WITH_HTTP WITH_ICONV WITH_ICU WITH_ISO8859X WITH_LEGACY WITH_LZMA WITH_MEM_DEBUG WITH_MODULES WITH_OUTPUT WITH_PATTERN WITH_PUSH WITH_READER WITH_REGEXPS WITH_RUN_DEBUG WITH_SAX1 WITH_SCHEMAS WITH_SCHEMATRON WITH_THREADS WITH_THREAD_ALLOC WITH_TREE WITH_TRIO WITH_UNICODE WITH_VALID WITH_WRITER WITH_XINCLUDE WITH_XPATH WITH_XPTR WITH_ZLIB)
	if(LIBXML2_${VARIABLE})
		set(${VARIABLE} 1)
	else()
		set(${VARIABLE} 0)
	endif()
endforeach()

set(LIBXML_VERSION ${VERSION})
set(LIBXML_VERSION_EXTRA "")
math(EXPR LIBXML_VERSION_NUMBER "
    ${LIBXML_MAJOR_VERSION} * 10000 +
    ${LIBXML_MINOR_VERSION} * 100 +
    ${LIBXML_MICRO_VERSION}
")

set(MODULE_EXTENSION "${CMAKE_SHARED_LIBRARY_SUFFIX}")

set(PACKAGE "libxml2")
set(PACKAGE_BUGREPORT "xml@gnome.org")
set(PACKAGE_NAME "libxml2")
set(PACKAGE_STRING "libxml2 ${VERSION}")
set(PACKAGE_TARNAME "libxml2")
set(PACKAGE_URL "https://gitlab.gnome.org/GNOME/libxml2")
set(PACKAGE_VERSION ${VERSION})

if(LIBLZMA_FOUND)
	list(APPEND CMAKE_REQUIRED_LIBRARIES LibLZMA::LibLZMA)
endif()

if(Threads_FOUND)
	list(APPEND CMAKE_REQUIRED_LIBRARIES Threads::Threads)
endif()

if(ZLIB_FOUND)
	list(APPEND CMAKE_REQUIRED_LIBRARIES ZLIB::ZLIB)
endif()

if(MSVC)
	configure_file(include/win32config.h config.h COPYONLY)
else()
	check_c_source_compiles("
		void __attribute__((destructor))
		f(void) {}
		int main(void) { return 0; }
	" HAVE_ATTRIBUTE_DESTRUCTOR)
	if(HAVE_ATTRIBUTE_DESTRUCTOR)
		set(ATTRIBUTE_DESTRUCTOR "__attribute__((destructor))")
	endif()
	check_c_source_compiles("
		#include <netdb.h>
		int main() { (void) gethostbyname((const char*) \"\"); return 0; }
	" GETHOSTBYNAME_ARG_CAST_CONST)
	if(NOT GETHOSTBYNAME_ARG_CAST_CONST)
		set(GETHOSTBYNAME_ARG_CAST "(char *)")
	else()
		set(GETHOSTBYNAME_ARG_CAST "/**/")
	endif()
	check_include_files(arpa/inet.h HAVE_ARPA_INET_H)
	check_include_files(arpa/nameser.h HAVE_ARPA_NAMESER_H)
	check_struct_has_member("struct sockaddr_storage" ss_family "sys/socket.h;sys/types.h" HAVE_SS_FAMILY)
	check_struct_has_member("struct sockaddr_storage" __ss_family "sys/socket.h;sys/types.h" HAVE_BROKEN_SS_FAMILY)
	if(HAVE_BROKEN_SS_FAMILY)
		set(ss_family __ss_family)
	endif()
	check_function_exists(class HAVE_CLASS)
	check_include_files(ctype.h HAVE_CTYPE_H)
	check_include_files(dlfcn.h HAVE_DLFCN_H)
	check_library_exists(dl dlopen "" HAVE_DLOPEN)
	check_include_files(dl.h HAVE_DL_H)
	check_include_files(errno.h HAVE_ERRNO_H)
	check_include_files(fcntl.h HAVE_FCNTL_H)
	check_include_files(float.h HAVE_FLOAT_H)
	check_function_exists(fpclass HAVE_FPCLASS)
	check_function_exists(fprintf HAVE_FPRINTF)
	check_function_exists(ftime HAVE_FTIME)
	check_function_exists(getaddrinfo HAVE_GETADDRINFO)
	check_function_exists(gettimeofday HAVE_GETTIMEOFDAY)
	check_include_files(inttypes.h HAVE_INTTYPES_H)
	check_function_exists(isascii HAVE_ISASCII)
	check_library_exists(history append_history "" HAVE_LIBHISTORY)
	check_library_exists(readline readline "" HAVE_LIBREADLINE)
	check_include_files(limits.h HAVE_LIMITS_H)
	check_function_exists(localtime HAVE_LOCALTIME)
	check_include_files(malloc.h HAVE_MALLOC_H)
	check_include_files(math.h HAVE_MATH_H)
	check_function_exists(mmap HAVE_MMAP)
	check_function_exists(munmap HAVE_MUNMAP)
	check_include_files(netdb.h HAVE_NETDB_H)
	check_include_files(netinet/in.h HAVE_NETINET_IN_H)
	check_include_files(poll.h HAVE_POLL_H)
	check_function_exists(printf HAVE_PRINTF)
	check_include_files(pthread.h HAVE_PTHREAD_H)
	check_function_exists(putenv HAVE_PUTENV)
	check_function_exists(rand HAVE_RAND)
	check_function_exists(rand_r HAVE_RAND_R)
	check_include_files(resolv.h HAVE_RESOLV_H)
	check_library_exists(dld shl_load "" HAVE_SHLLOAD)
	check_include_files(signal.h HAVE_SIGNAL_H)
	check_function_exists(snprintf HAVE_SNPRINTF)
	check_function_exists(sprintf HAVE_SPRINTF)
	check_function_exists(srand HAVE_SRAND)
	check_function_exists(sscanf HAVE_SSCANF)
	check_function_exists(stat HAVE_STAT)
	check_include_files(stdarg.h HAVE_STDARG_H)
	check_include_files(stdint.h HAVE_STDINT_H)
	check_include_files(stdlib.h HAVE_STDLIB_H)
	check_function_exists(strftime HAVE_STRFTIME)
	check_include_files(strings.h HAVE_STRINGS_H)
	check_include_files(string.h HAVE_STRING_H)
	check_include_files(sys/mman.h HAVE_SYS_MMAN_H)
	check_include_files(sys/select.h HAVE_SYS_SELECT_H)
	check_include_files(sys/socket.h HAVE_SYS_SOCKET_H)
	check_include_files(sys/stat.h HAVE_SYS_STAT_H)
	check_include_files(sys/timeb.h HAVE_SYS_TIMEB_H)
	check_include_files(sys/time.h HAVE_SYS_TIME_H)
	check_include_files(sys/types.h HAVE_SYS_TYPES_H)
	check_function_exists(time HAVE_TIME)
	check_include_files(time.h HAVE_TIME_H)
	check_include_files(unistd.h HAVE_UNISTD_H)
	check_function_exists(va_copy HAVE_VA_COPY)
	check_function_exists(vfprintf HAVE_VFPRINTF)
	check_function_exists(vsnprintf HAVE_VSNPRINTF)
	check_function_exists(vsprintf HAVE_VSPRINTF)
	check_function_exists(__va_copy HAVE___VA_COPY)
	check_c_source_compiles("
		#include <stdlib.h>
		#include <iconv.h>
		extern
		#ifdef __cplusplus
		\"C\"
		#endif
		#if defined(__STDC__) || defined(__cplusplus)
		size_t iconv(iconv_t cd, char** inbuf, size_t* inbytesleft, char** outbuf, size_t* outbytesleft);
		#else
		size_t iconv();
		#endif
		int main() { return 0; }
	" ICONV_CONST_TEST)
	if(NOT ICONV_CONST_TEST)
		set(ICONV_CONST "const")
	endif()
	set(LT_OBJDIR ".libs/")
	check_c_source_compiles("
		#include <sys/socket.h>
		#include <sys/types.h>
		int main() { (void) send(1, (const char*) \"\", 1, 1); return 0; }
	" SEND_ARG2_CAST_CONST)
	if(NOT SEND_ARG2_CAST_CONST)
		set(SEND_ARG2_CAST "(char *)")
	else()
		set(SEND_ARG2_CAST "/**/")
	endif()
	check_include_files("float.h;stdarg.h;stdlib.h;string.h" STDC_HEADERS)
	check_c_source_compiles("
		#include <stdarg.h>
		void a(va_list* ap) {};
		int main() { va_list ap1, ap2; a(&ap1); ap2 = (va_list) ap1; return 0; }
	" VA_LIST_IS_ARRAY_TEST)
	if(VA_LIST_IS_ARRAY_TEST)
		set(VA_LIST_IS_ARRAY FALSE)
	else()
		set(VA_LIST_IS_ARRAY TRUE)
	endif()
	check_c_source_compiles("
		#include <stddef.h>
		#include <sys/socket.h>
		#include <sys/types.h>
		int main() { (void) getsockopt(1, 1, 1, NULL, (socklen_t*) NULL); return 0; }
	" XML_SOCKLEN_T_SOCKLEN_T)
	if(XML_SOCKLEN_T_SOCKLEN_T)
		set(XML_SOCKLEN_T socklen_t)
	else()
		check_c_source_compiles("
			#include <stddef.h>
			#include <sys/socket.h>
			#include <sys/types.h>
			int main() { (void) getsockopt(1, 1, 1, NULL, (size_t*) NULL); return 0; }
		" XML_SOCKLEN_T_SIZE_T)
		if(XML_SOCKLEN_T_SIZE_T)
			set(XML_SOCKLEN_T size_t)
		else()
			check_c_source_compiles("
				#include <stddef.h>
				#include <sys/socket.h>
				#include <sys/types.h>
				int main() { (void) getsockopt (1, 1, 1, NULL, (int*) NULL); return 0; }
			" XML_SOCKLEN_T_INT)
			set(XML_SOCKLEN_T int)
		endif()
	endif()
	configure_file(config.h.cmake.in config.h)
endif()

set(
	LIBXML2_HDRS
	include/libxml/c14n.h
	include/libxml/catalog.h
	include/libxml/chvalid.h
	include/libxml/debugXML.h
	include/libxml/dict.h
	include/libxml/DOCBparser.h
	include/libxml/encoding.h
	include/libxml/entities.h
	include/libxml/globals.h
	include/libxml/hash.h
	include/libxml/HTMLparser.h
	include/libxml/HTMLtree.h
	include/libxml/list.h
	include/libxml/nanoftp.h
	include/libxml/nanohttp.h
	include/libxml/parser.h
	include/libxml/parserInternals.h
	include/libxml/pattern.h
	include/libxml/relaxng.h
	include/libxml/SAX.h
	include/libxml/SAX2.h
	include/libxml/schemasInternals.h
	include/libxml/schematron.h
	include/libxml/threads.h
	include/libxml/tree.h
	include/libxml/uri.h
	include/libxml/valid.h
	include/libxml/xinclude.h
	include/libxml/xlink.h
	include/libxml/xmlIO.h
	include/libxml/xmlautomata.h
	include/libxml/xmlerror.h
	include/libxml/xmlexports.h
	include/libxml/xmlmemory.h
	include/libxml/xmlmodule.h
	include/libxml/xmlreader.h

=== debian/changelog ===
libxml2 (2.12.7+dfsg+really2.9.14-2.1+deb13u2) trixie; urgency=high

  * Non-maintainer upload.
  * Fix CVE-2025-9714: Denial of service vulnerability via uncontrolled
    recursion in XPath evaluation.
  * Amend d/p/CVE-2025-7425.patch to better reflect the original fix.

 -- Guilhem Moulin <guilhem@debian.org>  Sat, 11 Oct 2025 14:55:59 +0200

libxml2 (2.12.7+dfsg+really2.9.14-2.1+deb13u1) trixie-security; urgency=high

  * CVE-2025-7425: heap-use-after-free in xmlFreeID caused by `atype`
    corruption (Closes: #1109122)

 -- Aron Xu <aron@debian.org>  Mon, 25 Aug 2025 19:38:04 +0800

libxml2 (2.12.7+dfsg+really2.9.14-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Fix CVE-2025-6170: Potential buffer overflows in the interactive shell
    (Closes: #1107938).

 -- Guilhem Moulin <guilhem@debian.org>  Sun, 27 Jul 2025 00:59:51 +0200

libxml2 (2.12.7+dfsg+really2.9.14-2) unstable; urgency=medium

  * Security fixes:
    - CVE-2025-6021: integer overflow in xmlBuildQName()
      (Closes: #1107720)
    - CVE-2025-{49794,49796}: use after free and type confusion in
      xmlSchematronReportOutput() (Closes: #1107755)

 -- Aron Xu <aron@debian.org>  Thu, 17 Jul 2025 17:09:57 +0200

libxml2 (2.12.7+dfsg+really2.9.14-1) unstable; urgency=medium

  * Acknowledge previous NMUs.
  * Security fixes:
    - CVE-2023-39615: out-of-bounds read via the xmlSAX2StartElement()
      (Closes: #1051230)
    - CVE-2023-45322: use-after-free in xmlUnlinkNode()
      (Closes: #1053629)
    - CVE-2024-25062: use-after-free in xmlValidatePopElement()
      (Closes: #1063234)
    - CVE-2025-32414: out-of-bounds read in Python bindings
      (Closes: #1102521)
    - CVE-2025-32415: heap-based buffer under-read via
      xmlSchemaIDCFillNodeTables() (Closes: #1103511)

 -- Aron Xu <aron@debian.org>  Thu, 15 May 2025 15:34:25 +0800

=== debian/control ===
--- 
+++ 
@@ -8,18 +8,17 @@
 Build-Depends:
  debhelper-compat (= 13),
 Build-Depends-Indep:
- pkgconf,
+ pkg-config,
 Build-Depends-Arch:
  dh-sequence-python3 <!nopython>,
- libicu-dev <!noi18n>,
  liblzma-dev,
  libpython3-all-dev <!nopython>,
- pkgconf,
+ pkg-config,
  python3-all-dev:any (>= 3.5) <!nopython>,
- python3-setuptools,
+ python3-setuptools <!nopython>,
  rename,
  zlib1g-dev | libz-dev,
-Standards-Version: 4.6.2
+Standards-Version: 4.6.0
 Rules-Requires-Root: no
 Homepage: http://xmlsoft.org
 Vcs-Git: https://salsa.debian.org/xml-sgml-team/libxml2.git
@@ -41,8 +40,6 @@
  ${shlibs:Depends},
 Conflicts:
  w3c-dtd-xhtml,
-Breaks:
- libxml-libxml-perl (<< 2.0207+dfsg+really+2.0134-3~),
 Multi-Arch: same
 Description: ${source:Synopsis}
  ${source:Extended-Description}
@@ -68,13 +65,10 @@
 Architecture: any
 Section: libdevel
 Depends:
- libicu-dev,
- liblzma-dev,
  libxml2 (= ${binary:Version}),
- zlib1g-dev,
  ${misc:Depends},
 Suggests:
- pkgconf,
+ pkg-config,
 Multi-Arch: same
 Description: ${source:Synopsis} - development files
  ${source:Extended-Description}
@@ -100,6 +94,7 @@
 Architecture: any
 Build-Profiles: <!nopython>
 Section: python
+Multi-Arch: same
 Depends:
  ${misc:Depends},
  ${python3:Depends},

=== debian/rules ===
--- 
+++ 
@@ -12,33 +12,25 @@
 
 export DEB_BUILD_MAINT_OPTIONS=hardening=+all
 export DEB_CFLAGS_MAINT_APPEND = -Wall -O3
+export DEB_LDFLAGS_MAINT_APPEND = -Wl,--no-as-needed
 
 include /usr/share/dpkg/architecture.mk
 
 TARGETS := main $(PY3VERS)
 
-CONFIGURE_FLAGS := --with-history \
-		   --with-legacy \
-		   --with-ftp \
-		   --with-xptr-loc
+CONFIGURE_FLAGS := --with-history --cache-file="$(CURDIR)/builddir/config.cache"
 
 override_dh_auto_configure-arch: $(TARGETS:%=doconfigure-%)
 
 override_dh_auto_configure-indep:
-	dh_auto_configure -- --docdir \$${prefix}/share/doc/libxml2 --enable-rebuild-docs --with-python=no
+	dh_auto_configure -- --docdir \$${prefix}/share/doc/libxml2 --enable-rebuild-docs --without-python
 
 doconfigure-%:
-	export PYTHON=$(PYTHON) && dh_auto_configure --builddirectory=builddir/$(*) -- $(CONFIGURE_FLAGS) && unset PYTHON
+	dh_auto_configure --builddirectory=builddir/$(*) -- $(CONFIGURE_FLAGS)
 	touch $@
 
-ifeq (,$(filter noi18n,$(DEB_BUILD_PROFILES)))
-doconfigure-main: CONFIGURE_FLAGS += --with-python=no --with-icu
-else
-doconfigure-main: CONFIGURE_FLAGS += --with-python=no
-endif
-doconfigure-python%: CONFIGURE_FLAGS += --with-python
-	#PYTHON_VERSION=$(subst python,,$(*))
-	PYTHON=$(shell which $(*))
+doconfigure-main: CONFIGURE_FLAGS += --without-python
+doconfigure-python%: CONFIGURE_FLAGS += --with-python=/usr/bin/$(*) --with-python-install-dir=/usr/lib/$(*)/dist-packages
 
 dobuild-%: BUILD_DIR=builddir/$(*)
 dobuild-%: doconfigure-%
@@ -68,7 +60,10 @@
 
 override_dh_auto_install-arch: $(TARGETS:%=doinstall-%)
 	find debian/tmp -name *.la -delete
-	rm -r debian/tmp/usr/lib/python*/site-packages/__pycache__
+
+override_dh_auto_install-indep:
+	dh_auto_install -i
+	rm -v debian/tmp/usr/share/doc/libxml2/Copyright
 
 doinstall-python%:
 	dh_auto_install --builddirectory=builddir/main/python$(*)
@@ -87,6 +82,7 @@
 	dh_makeshlibs -plibxml2 -V 'libxml2 (>= 2.9.11)' -- -c4
 	dh_makeshlibs --remaining-packages
 
+
 #  I need to specify all the targets (build, binary, clean, etc) as
 #  otherwise dh may invoke them in a order that is not appropriate for the
 #  build system (the -indep part is done in-tree because rebuilding the
@@ -98,7 +94,3 @@
 
 build: build-arch build-indep
 binary: binary-arch binary-indep
-
-dfsg-source-tree:
-	rm -rf test/
-	rm -rf result/
